//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A9529DA02DF.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A9529DA02DF.cm

//## begin module%3A9529DA02DF.cp preserve=no
//## end module%3A9529DA02DF.cp

//## Module: ParamCreator%3A9529DA02DF; Package body
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Parameter/ParamCreator.cxx

//## begin module%3A9529DA02DF.additionalIncludes preserve=no
//## end module%3A9529DA02DF.additionalIncludes

//## begin module%3A9529DA02DF.includes preserve=yes
#include <XSModel/Model/Component/ComponentBase.h>
//## end module%3A9529DA02DF.includes

// ModParam
#include <XSModel/Parameter/ModParam.h>
// SwitchParam
#include <XSModel/Parameter/SwitchParam.h>
// ScaleParam
#include <XSModel/Parameter/ScaleParam.h>
// ParamCreator
#include <XSModel/Parameter/ParamCreator.h>
//## begin module%3A9529DA02DF.declarations preserve=no
//## end module%3A9529DA02DF.declarations

//## begin module%3A9529DA02DF.additionalDeclarations preserve=yes
//## end module%3A9529DA02DF.additionalDeclarations


// Class Utility ParamCreator 


//## Other Operations (implementation)
Parameter* ParamCreator::MakeParameter (std::string initString, ComponentBase* p, size_t paramIndex)
{
  //## begin ParamCreator::MakeParameter%3A9529B80209.body preserve=yes
  Parameter* q;
  char indicator(initString[0]);
  switch (indicator)
  {
        case '$':
           q = new SwitchParam(initString,p); 
           break;
        case '*': 
           q = new ScaleParam(initString,p); 
           break;
        default: 
           {
              string parName, unit;
              Real val=.0,delta=.0,high=.0,low=.0,top=.0,bot=.0;
              bool isPeriodic = false;
              ModParam::parseModParamString(initString, parName, &val, &delta,
                        &high, &low, &top, &bot, unit, &isPeriodic); 
              q = new ModParam(parName,p,val,delta,high,low,top,bot,
                        unit,isPeriodic);
           }
           break;         
  }
  q->index(paramIndex);
  return q;
  //## end ParamCreator::MakeParameter%3A9529B80209.body
}

// Additional Declarations
  //## begin ParamCreator%3A95296C00FB.declarations preserve=yes
  //## end ParamCreator%3A95296C00FB.declarations

//## begin module%3A9529DA02DF.epilog preserve=yes
//## end module%3A9529DA02DF.epilog
